Player=Turbine.Gameplay.LocalPlayer:GetInstance();

VBarButton={}
	VBarButton.Window=Turbine.UI.Window()
	VBarButton.Window:SetVisible(true)
	VBarButton.Window.DragBar = Deusdictum.UI.DragBar( VBarButton.Window,"VBar")
	VBarButton.Window:SetPosition(Option.X,Option.Y)
	VBarButton.Window:SetSize(32,32)
	VBarButton.Window:SetOpacity(1)
	VBarButton.Window:SetMouseVisible(true)
	VBarButton.Window:SetBackground(0x410080ae)
	VBarButton.Window:SetStretchMode(1)
	VBarButton.Window:SetSize(32*Option.Scale,32*Option.Scale)
	
	VBarButton.Cover=Turbine.UI.Control()
	VBarButton.Cover:SetVisible(true)
	VBarButton.Cover:SetParent(VBarButton.Window)
	VBarButton.Cover:SetPosition(0,0)
	VBarButton.Cover:SetSize(64,64)
	VBarButton.Cover:SetBackground(0x410080af)
	VBarButton.Cover:SetVisible(false)
	
	VBarButton.Window.DragEnable=function() VBarButton.Cover:SetVisible(true)  end
	VBarButton.Window.DragDisable=function() VBarButton.Cover:SetVisible(false) end
	
	Player:RegisterForClickHandling(VBarButton.Window)
	
	VBarButton.Window.MouseEnter=function()
		Mtemp=Morale:GetOpacity()
		Ptemp=Power:GetOpacity()
		Morale:SetOpacity(1)
		Power:SetOpacity(1)
	end
	
	VBarButton.Window.MouseLeave=function()
		Morale:SetOpacity(Mtemp)
		Power:SetOpacity(Ptemp)
	end
		
	VBarButton.Cover.MouseDown=function(sender,args)
			
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				moving=true
				--Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, shown );
			end
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
		
				local contextMenu = Turbine.UI.ContextMenu()
				contextMenu.items = contextMenu:GetItems()

				local option1 = Turbine.UI.MenuItem("Show Morale text/percentage")
					contextMenu.SubMenuItems = option1:GetItems()
					local suboption1={}
						suboption1[1] = Turbine.UI.MenuItem("Text Curr/Max",true,Option.mtxt)
						suboption1[1].Click = function () Option.mper=false Option.mtxt=true MoraleChanged() Morale:SetFill(0.8) Morale:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[1])
						suboption1[2] = Turbine.UI.MenuItem("Percentage",true,Option.mper)
						suboption1[2].Click = function ()  Option.mper=true Option.mtxt=false MoraleChanged() Morale:SetFill(0.8) Morale:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[2])
						suboption1[3] = Turbine.UI.MenuItem("None",true,not(Option.mtxt or Option.mper))
						suboption1[3].Click = function () Option.mper=false Option.mtxt=false Morale:SetText("") MoraleChanged() Morale:SetFill(0.8) Morale:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption1[3])
						
				contextMenu.items:Add(option1)
				
				local option2 = Turbine.UI.MenuItem("Show Power text/percentage")
					contextMenu.SubMenuItems = option2:GetItems()
					local suboption2={}
						suboption2[1] = Turbine.UI.MenuItem("Text Curr/Max",true,Option.ptxt)
						suboption2[1].Click = function () Option.pper=false Option.ptxt=true PowerChanged() Power:SetFill(0.8) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption2[1])
						suboption2[2] = Turbine.UI.MenuItem("Percentage",true,Option.pper)
						suboption2[2].Click = function ()  Option.pper=true Option.ptxt=false PowerChanged() Power:SetFill(0.8) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption2[2])
						suboption2[3] = Turbine.UI.MenuItem("None",true,not(Option.ptxt or Option.pper))
						suboption2[3].Click = function () Option.pper=false Option.ptxt=false Power:SetText("") Power:SetFill(0.8) Power:SetOpacity(1) end

						contextMenu.SubMenuItems:Add(suboption2[3])
						
				contextMenu.items:Add(option2)
				
				local option3 = Turbine.UI.MenuItem("Full opacity when lost;")
					contextMenu.SubMenuItems = option3:GetItems()
					local suboption3={}
					for i=0,20 do
						--The opacity modifier set the "range" of the fade. For example; at 20% the bar will be at full opacity when 20% is lost, then there is a graduated scale up to invisble at 100%
						 txt=i*5 .. "%"
						if i==0 then txt="Always visible" end
						suboption3[i] = Turbine.UI.MenuItem(txt,true,i*5/100==Option.Opacity)
						suboption3[i].Click = function () Option.Opacity=i*5./100 end

						contextMenu.SubMenuItems:Add(suboption3[i])
					end
				contextMenu.items:Add(option3)
				
				local option5 = Turbine.UI.MenuItem("Select Font;")
					contextMenu.SubMenuItems = option5:GetItems()
					local suboption5={}
					local font={}
					j=1
					for i in pairs(Turbine.UI.Lotro.Font) do 
						font[j]=i
						j=j+1
					end
					table.sort(font, function (a,b)	
							return (a < b) 
					 end)
					 for i=1,#font do
						suboption5[i] = Turbine.UI.MenuItem(font[i],true,font[i]==Option.Font)
						suboption5[i].Click = function () 
							Option.Font=font[i] 
							Morale.Text:SetFont(Turbine.UI.Lotro.Font[Option.Font]) 
							Power.Text:SetFont(Turbine.UI.Lotro.Font[Option.Font])
							
							PowerChanged() Power:SetFill(0.8) Power:SetOpacity(1)
							MoraleChanged() Morale:SetFill(0.8) Morale:SetOpacity(1)
							
						end

						contextMenu.SubMenuItems:Add(suboption5[i])
					end
				contextMenu.items:Add(option5)				
				
				
				txt="Show"
				if Option.shown then txt="Hide" end
				
				local option4 = Turbine.UI.MenuItem(txt.." default vitals",true)
					option4.Click=function() Option.shown=not(Option.shown) Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, Option.shown ) end
					
				contextMenu.items:Add(option4)
				
			
				

			contextMenu:ShowMenu()
			end
		end
	
	VBarButton.Cover.MouseUp=function(sender,args)
		moving=false
	end
	
	VBarButton.Cover.MouseMove=function(sender,args)
			if moving then
			local x,y=VBarButton.Window:GetMousePosition()

			Option.Scale=math.max(x,y)/32
			if Option.Scale<0.25 then Option.Scale=0.25 end

			VBarButton.Window:SetSize(32*Option.Scale,32*Option.Scale)
			VBarButton.Window.DragBar:Refresh()
		end
	end
	
		function VBarButton.Window:GetWidth()
		return 32*Option.Scale
	end
	function VBarButton.Window:GetHeight()
		return 32*Option.Scale
	end
	function VBarButton.Window:GetSize()
		return 32*Option.Scale ,32*Option.Scale
	end
	
	VBarButton.Window.DragBar:Refresh()
		
	VBarButton.Window.DragEnd=function ()
		Option.X,Option.Y=VBarButton.Window:GetPosition()
	end
	